#include FOXPRO.H
#include ERRORMGR.H

* Control characters.

#define ccNULL                  chr(0)
#define ccCR                    chr(13)
#define ccTAB                   chr(9)

* Strings to substitute in error and other messages.

#define ccMSG_INSERT1           '<Insert1>'
#define ccMSG_INSERT2           '<Insert2>'
#define ccMSG_INSERT3           '<Insert3>'

* Messages

#define ccMSG_LOCATE_WIN95      '<Insert1>:'
#define ccMSG_WANT_TO_QUIT      'Are you sure you want to quit?'
#define ccMSG_REC_MODIFIED      'Another user also changed this record. Do you want to overwrite their changes?'
#define ccMSG_DELETE_RECORD     'Delete this record?'
#define ccMSG_HOT_REENTER       '\<Reenter'
#define ccMSG_HOT_LIST          '\<List'
#define ccMSG_HOT_ADD           '\<Add'
#define ccMSG_LIST              'List'
#define ccMSG_ADD               'Add'

* VFP error numbers:

#define cnERR_TOO_FEW_ARGS      1229
	* too few arguments
#define cnERR_FILE_NOT_FOUND       1
	* file not found
#define cnERR_ALIAS_NOTFOUND      13
	* Alias is not found.
#define cnERR_ARRAYDIM           230
   * Bad array dimensions.
#define cnERR_RECINUSE           109
#define cnERR_TRIGGER_FAILED    1539
#define cnERR_PRIM_KEY_INVALID  1567
#define cnERR_NONULLS           1581
#define cnERR_FIELD_RULE_FAILED 1582
#define cnERR_TABLE_RULE_FAILED 1583
#define cnERR_RECMODIFIED       1585
#define cnERR_ACCESS_DENIED     1705
#define cnERR_DUPLKEY           1884
#define cnERR_DE_UNLOADED       1967
#define cnERR_TABLE_IN_USE      1995
#define cnERR_TABLE_MOVED       2004

* Error messages.

#define ccERR_TABLE_NOT_OPEN    '<Insert1> is not open.'
#define ccERR_DB_NOT_OPEN       'The database <Insert1> is not open.'
#define ccERR_NO_TABLE_SELECTED 'No table was specified.'
#define ccERR_NO_FIELD          'No field was specified.'
#define ccERR_PRIM_COMPOUND     'The primary key for <Insert1> is a compound key.'
#define ccERR_BAD_FORM_NAME     'Application manager OpenForm called with improper form name.'
#define ccERR_FILE_NOT_FOUND    '<Insert1> cannot be found.'
#define ccERR_NO_FORMS          'You do not have access to any forms. Please see your supervisor.'
#define ccERR_RECORD_IN_USE     'Someone else is currently editing this record.'
#define ccERR_BAD_STARTUP       '<Insert1> is not a valid startup action.'
#define ccERR_CANT_ADD          'A record cannot be added right now. Please try again later.'
#define ccERR_USER_DELETED      'Your user record has been deleted. Please see your supervisor.'
#define ccERR_CANT_DELETE       'You cannot delete this record since other records depend on it.'
#define ccERR_CANT_INSERT       'You have not completed all the information for this record.'
#define ccERR_CANT_UPDATE       'You cannot update this record since other records depend on it.'
#define ccERR_BAD_DRIVE         'Please specify a valid drive.'
#define ccERR_LOOKUP_FAILED     'That value was not found. What would you like to do?'
#define ccERR_FIELD_RULE_FAILED 'You entered an improper value.'
#define ccERR_REC_MODIFIED      'Another user changed this record. It will be redisplayed.'
#define ccERR_REC_MODIFIED_FAIL 'This record cannot be saved.'
#define ccERR_TABLE_MOVED       'One of the tables used by this form cannot be located. Please inform application support staff.'
#define ccERR_ACCESS_DENIED     'One of the tables used by this form is currently being used exclusively by another user. Please try again later.'
#define ccERR_TABLE_IN_USE      'One of the tables used by this form is currently being used exclusively by another process you are running. Please try again later.'
#define ccERR_PRIM_KEY_INVALID  'One of the tables used by this form needs to be reindexed. Please do so and try again.'

* Miscellaneous constants.

#define cnLARGE_BUFFER_SIZE     2048
#define ccVFP_VALIDATION_MSG    'validation rule is violated'

* Application class constants.

#define cwWINDOW_PAD            Window
#define ccWINDOW_PAD            'Window'
	* the name of the Window pad

* Application class aForms array columns.

#define cnFORMS_SCX_NAME        1
#define cnFORMS_OBJ_REF         2
#define cnFORMS_TOOLBAR_REF     3
#define cnFORMS_TOOLBAR_NAME    4
#define cnFORMS_ALLOW_MULT      5
#define cnFORMS_INSTANCE        6
#define cnFORMS_FORM_NAME       7
#define cnFORMS_ADD_WINDOW      8
#define cnFORMS_ARRAY_COLS      cnFORMS_ADD_WINDOW
